#include "utils.h"

int main(int argc, char const *argv[]) {
  vec_2 u,v,w;

  v = nullvector();
  vec_print(stdout, v, "v: null # ");

  w = nullvector();

  u = (vec_2){.x = 1, .y = 1};
  vec_print(stdout, u, "u: 1|1 # ");

  w = add(v,u);
  vec_print(stdout, w, "w: 1|1 # ");

  w = neg(w);
  vec_print(stdout, w, "w: -(1|1) # ");

  v = u;
  vec_print(stdout, v, "v: 1|1 # ");

  v = minus(u,neg(w));
  vec_print(stdout, v, "v: 0|0 # ");

  v = add(u,u);
  printf("magn v: %"PRIu64"\n", magnitude(v));

  u = scale_vec (v,11.11);
  vec_print(stdout, u, "u: 22|22 # ");

  printf("skalar prod: %d\n", skalar_prod(u,u));

  printf("t|f: %d\n", lin_dep(u,(vec_2){.x=10,.y=10}));
  printf("t|f: %d\n", lin_dep(u,(vec_2){.x=10,.y=5}));

  printf("%"PRIu64"\n", (uint64_t) pow(27.0,1/3.0));

  return 0;
}
