#include "utils.h"


vec_2 nullvector()
{
  return (vec_2) {.x = 0, .y=0};
}

uint64_t magnitude(vec_2 v)
{
  return (uint64_t) sqrt(v.x * v.x + v.y * v.y);
}

/* scales vec_2 v by l */
vec_2 scale_vec(vec_2 v, double l)
{
  if (0 > (double) v.x * l)
  {
    v.x = (int64_t) floor((double) v.x * l);
  }
  else
  {
    v.x = (int64_t) ceil((double) v.x * l);
  }
  if (0 > (double) v.y * l)
  {
    v.y = (int64_t) floor((double) v.y * l);
  }
  else
  {
    v.y = (int64_t) ceil((double) v.y * l);
  }
  return v;
}

/* sum of two vectors vec_2 */
vec_2 add(vec_2 a, vec_2 b)
{
  vec_2 t = a;
  t.x += b.x;
  t.y += b.y;
  return t;
}

/* negates a vector vec_2 */
vec_2 neg(vec_2 a)
{
  vec_2 t = a;
  t.x *= -1;
  t.y *= -1;
  return t;
}

/* subtracts two vectors */
vec_2 minus(vec_2 a, vec_2 b)
{
  return add(a, neg(b));
}

double skalar_prod(vec_2 a, vec_2 b)
{
  return (double) (a.x * b.x + a.y * b.y);
}

int64_t lin_dep(vec_2 a, vec_2 b)
{
  return skalar_prod(a, b) == sqrt(a.x * a.x + a.y * a.y) * sqrt(b.x * b.x + b.y * b.y);
}

void vec_print(FILE * f, vec_2 v, const char * label)
{
  fprintf(f, "%s x: %"PRIi64", y: %"PRIi64"\n", label, v.x, v.y);
}
